﻿using System.ComponentModel;

namespace CommandsSample {
   public abstract class NotifyPropertyChanged : INotifyPropertyChanged {
      public event PropertyChangedEventHandler PropertyChanged;

      protected virtual void OnPropertyChanged(PropertyChangedEventArgs e) {
         if (PropertyChanged != null) PropertyChanged(this, e);
      }
      protected virtual void OnPropertyChanged<T>(T value, ref T backingField,string propName) {
         if (object.Equals(value, backingField)) return;
         backingField = value;
         OnPropertyChanged(new PropertyChangedEventArgs(propName));
      }
   }
}
