﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
namespace CommandsSample {

   public class Person : NotifyPropertyChanged, IDataErrorInfo {

      private string _Name;
      public string Name {
         get { return _Name; }
         set { OnPropertyChanged(value, ref _Name, "Name"); }
      }
      private string _Phone;
      public string Phone {
         get { return _Phone; }
         set { OnPropertyChanged(value, ref _Phone, "Phone"); }
      }
      private DateTime _BirthDay;
      public DateTime BirthDay {
         get { return _BirthDay; }
         set { OnPropertyChanged(value, ref _BirthDay, "BirthDay"); }
      }
      public Person()  { }
      public Person(string name, string phone, DateTime birth) {
         _Name = name; _Phone = phone; _BirthDay = birth;
      }
      public void CopyTo(Person other) {
         other.Name = Name;
         other.Phone = Phone;
         other.BirthDay = BirthDay;
      }

      #region IDataErrorInfo
      public string Error { get; private set; }//Gesamt-Error
      public string this[string columnName] {//Error bestimmter Properties
         get {
            Error = null;
            switch (columnName) {
            case "Name":
               if (string.IsNullOrEmpty(_Name)) Error = "please input Name";
               break;
            case "BirthDay":
               if (_BirthDay.AddYears(18) > DateTime.Today) Error = "Person too young";
               break;
            }
            return Error;
         }
      }
      #endregion
   }
}
