﻿Imports System.Windows.Input

Public Class RelayCommand : Implements ICommand
   ReadOnly _Executer As Action
   ReadOnly _CanExecute As Func(Of Boolean)

   Public Custom Event CanExecuteChanged As EventHandler Implements ICommand.CanExecuteChanged
      AddHandler(ByVal value As EventHandler)
         AddHandler CommandManager.RequerySuggested, value
      End AddHandler
      RemoveHandler(ByVal value As EventHandler)
         RemoveHandler CommandManager.RequerySuggested, value
      End RemoveHandler
      RaiseEvent(sender As Object, e As EventArgs)
         CommandManager.InvalidateRequerySuggested()
      End RaiseEvent
   End Event

   Public Sub New(executer As Action, Optional canExecute As Func(Of Boolean) = Nothing)
      Me._Executer = executer
      Me._CanExecute = If(canExecute, Function() True)
   End Sub

   Public Function CanExecute(parameter As Object) As Boolean Implements ICommand.CanExecute
      Return _CanExecute.Invoke()
   End Function

   Public Sub Execute(parameter As Object) Implements ICommand.Execute
      _Executer.Invoke()
   End Sub
End Class
