﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports System.Windows.Data

Public Class MainViewModel : Inherits NotifyPropertyChanged

   Public Shared Property Instance() As New MainViewModel

   Public Property cmdCreatePersons() As New RelayCommand(AddressOf CreateManyPersons)

   Private Sub New()
      CreateManyPersons()
   End Sub

   Private __Persons As New ObservableCollection(Of Person)()
   Public Property Persons() As ICollectionView = CollectionViewSource.GetDefaultView(__Persons)

   Public Property cmdNew() As New RelayCommand(AddressOf CreateNewPerson)

   Public Property cmdDelete() As New RelayCommand( _
         Sub() __Persons.RemoveAt(Persons.CurrentPosition), _
         Function() Persons.CurrentPosition >= 0)

   Public Property cmdEdit() As New RelayCommand( _
         Sub() Call New wndPerson(__Persons(Persons.CurrentPosition)).ShowDialog(), _
         Function() Persons.CurrentPosition >= 0)

   Public Sub CreateNewPerson()
      Dim person = New Person("a Name", "-", DateTime.Now)
      Dim editor = New wndPerson(person)
      If CBool(editor.ShowDialog()) Then
         __Persons.Add(person)
         Persons.MoveCurrentToPosition(__Persons.Count - 1)
      End If
   End Sub

   Private Sub CreateManyPersons()
      Dim start = __Persons.Count
      Dim i = start + 10
      While System.Math.Max(System.Threading.Interlocked.Decrement(i), i + 1) > start
         __Persons.Add(New Person("Person" & i, "54321" & i, DateTime.Today.AddYears(-60 + i)))
      End While
   End Sub
End Class
