﻿Imports System.ComponentModel

Public Class Person : Inherits NotifyPropertyChanged : Implements IDataErrorInfo

   Private _Name As String
   Public Property Name() As String
      Get
         Return _Name
      End Get
      Set(value As String)
         OnPropertyChanged(value, _Name, "Name")
      End Set
   End Property
   Private _Phone As String
   Public Property Phone() As String
      Get
         Return _Phone
      End Get
      Set(value As String)
         OnPropertyChanged(value, _Phone, "Phone")
      End Set
   End Property
   Private _BirthDay As DateTime
   Public Property BirthDay() As DateTime
      Get
         Return _BirthDay
      End Get
      Set(value As DateTime)
         OnPropertyChanged(value, _BirthDay, "BirthDay")
      End Set
   End Property
   Public Sub New()
   End Sub
   Public Sub New(name As String, phone As String, birth As DateTime)
      _Name = name
      _Phone = phone
      _BirthDay = birth
   End Sub
   Public Sub CopyTo(other As Person)
      other.Name = Name
      other.Phone = Phone
      other.BirthDay = BirthDay
   End Sub

   Private _Error As String
   Public ReadOnly Property [Error] As String Implements IDataErrorInfo.Error
      Get
         Return _Error
      End Get
   End Property

   Default Public ReadOnly Property Item(columnName As String) As String Implements IDataErrorInfo.Item
      Get
         _Error = Nothing
         Select Case columnName
            Case "Name"
               If String.IsNullOrEmpty(_Name) Then _Error = "please input Name"
            Case "BirthDay"
               If _BirthDay.AddYears(18) > DateTime.Today Then _Error = "Person too young"
         End Select
         Return _Error
      End Get
   End Property

End Class
